// File edited 02/20/2015 with four space tab spacing
// File edited and added 3/12/2015

/** \file
	\brief Do stuff periodically
*/

#include "time_clock.h"
#include "pinio.h"
#include "dda_queue.h"
#include "debug.h"
#include "clock_timer.h"

/*!	do stuff every 1/4 second
	called from clock_10ms(), do not call directly
*/
static void clock_250ms(void)
{
	if(1)//3/12/2015//Bruce//heaters_all_zero())
	{
		if(psu_timeout > (30 * 4))
		{
			power_off();
		}
		else
		{
			//3/11/2015//Bruce//ATOMIC_START

			psu_timeout++;

			//3/11/2015//Bruce//ATOMIC_END
		}
	}

	ifclock(clock_flag_1s)
	{
		if(DEBUG_POSITION && (debug_flags & DEBUG_POSITION))
		{
			// current position
			update_current_position();
			print("Pos: %f,%f,%f,%f,%u\n",
				(double)current_position.X, (double)current_position.Y,
				(double)current_position.Z, (double)current_position.E,
				current_position.F);

			// target position
			print("Dst: %f,%f,%f,%f,%u\n",
				(double)movebuffer[mb_tail].endpoint.X,
				(double)movebuffer[mb_tail].endpoint.Y,
				(double)movebuffer[mb_tail].endpoint.Z,
				(double)movebuffer[mb_tail].endpoint.E,
				movebuffer[mb_tail].endpoint.F);

			// Queue
			print_queue();

			// newline
			print("\n");
		}
	}
}

/*! do stuff every 10 milliseconds
	called from clock(), do not call directly
*/
static void clock_10ms(void)
{
	//3/12/2015//Bruce//temp_tick();

	ifclock(clock_flag_250ms)
	{
		clock_250ms();
	}
}

/*! do reoccuring stuff
	call it occasionally in busy loops
*/
void clock_rs()
{
	ifclock(clock_flag_10ms)
	{
		clock_10ms();
	}
}